r73: mali cleanup u manualu
[carnet-tools-cn.git] / functions.sh
1 # by ddzeko & ico, Fri, 18 Mar 2005 14:44:08 +0100
2 cp_get_ifaddr() {
3   [ "$CP_SCRIPT_DEBUG" ] && set -vx
4   local ifaddr interface echo_return
5   echo_return="$CP_ECHO_RETURN" # since we're making our own calls
6   # in our own way we need to set CP_ECHO_RETURN the way we want it
7   # but preserving initial state so it could be used afterwards
8   CP_ECHO_RETURN=""
9
10   interface="$1"
11   if [ -z "$interface" ]; then
12     cp_get_ifdefault dev
13     interface="$RET"
14     [ -z "$interface" ] && interface=lo
15   fi
16
17   if ! ifconfig $interface 2> /dev/null >> /dev/null; then
18     echo "cp_get_ifaddr: $interface: No such interface" 1>&2
19     CP_ECHO_RETURN="$echo_return"
20     return 2
21   fi
22
23   ifaddr="`/sbin/ifconfig $interface | awk '/inet/{ printf("%s\n",substr($2,index($2,":")+1)) }'`"
24
25   if [ -z $ifaddr ]; then
26     echo "cp_get_ifaddr: $interface: No ip address found" 1>&2
27     CP_ECHO_RETURN="$echo_return"
28     return 1
29   fi
30
31   RET="$ifaddr"
32   [ -z "$echo_return" ] || echo $RET
33   CP_ECHO_RETURN="$echo_return"
34 }
35
36 # by ddzeko & ico, Fri, 18 Mar 2005 14:44:08 +0100
37 cp_get_ifmask() {
38   [ "$CP_SCRIPT_DEBUG" ] && set -vx
39   local ifmask interface echo_return
40   echo_return="$CP_ECHO_RETURN" # since we're making our own calls
41   # in our own way we need to set CP_ECHO_RETURN the way we want it
42   # but preserving initial state so it could be used afterwards
43   CP_ECHO_RETURN=""
44
45   interface="$1"
46   if [ -z "$interface" ]; then
47     cp_get_ifdefault dev
48     interface="$RET"
49     [ -z "$interface" ] && interface=lo
50   fi
51
52   if ! ifconfig $interface 2> /dev/null >> /dev/null; then
53     echo "cp_get_ifmask: $interface: No such interface" 1>&2
54     CP_ECHO_RETURN="$echo_return"
55     return 1
56   fi
57
58   ifmask="`/sbin/ifconfig $interface | awk '/Mask/{if($3~/Mask/)a=$3;else if ($4~/Mask/)a=$4;printf ("%s\n", substr(a,index(a,":")+1))}'`"
59
60   if [ -z "$ifmask" ]; then
61     echo "cp_get_ifmask: $interface: No netmask found" 1>&2
62     CP_ECHO_RETURN="$echo_return"
63     return 1
64   fi
65
66   RET="$ifmask"
67   [ -z "$echo_return" ] || echo $RET
68   CP_ECHO_RETURN="$echo_return"
69 }
70
71 # by ddzeko, Mon, 21 Mar 2005 07:00:22 +0100
72 cp_get_ifdefault() {
73   local echo_return
74   echo_return="$CP_ECHO_RETURN" # since we're making our own calls
75   # in our own way we need to set CP_ECHO_RETURN the way we want it
76   # but preserving initial state so it could be used afterwards
77   CP_ECHO_RETURN=""
78
79   [ "$CP_SCRIPT_DEBUG" ] && set -vx
80   RET=""
81   case $1 in
82     dev)  RET=`route -n | awk '/^0.0.0.0/{print $8}'` ;;
83     addr) RET=`route -n | awk '/^0.0.0.0/{print $2}'` ;;
84     *)    echo "cp_get_ifdefault: Argument required (dev or addr)" >&2 ;;
85   esac
86   [ -z "$RET" -a "$1" ] && echo "cp_get_ifdefault: No default route" >&2
87   [ -z "$echo_return" ] || echo $RET
88   CP_ECHO_RETURN="$echo_return"
89   [ -z "$RET" ] && return 1
90 }
91
92 # by ico, Tue, 15 Mar 2005 14:04:21 +0100
93 cp_get_netaddr() {
94   [ "$CP_SCRIPT_DEBUG" ] && set -vx
95   local netmask ipaddress interface cidr echo_return
96   echo_return="$CP_ECHO_RETURN" # since we're making our own calls
97   # in our own way we need to set CP_ECHO_RETURN the way we want it
98   # but preserving initial state so it could be used afterwards
99   CP_ECHO_RETURN=""
100
101   interface="$1"
102   if [ -z "$interface" ]; then
103     cp_get_ifdefault dev
104     interface="$RET"
105     [ -z "$interface" ] && interface=lo
106   fi
107
108   if ! ifconfig $interface 2> /dev/null >> /dev/null; then
109     echo "cp_get_netaddr: $interface: No such interface" 1>&2
110     CP_ECHO_RETURN="$echo_return"
111     return 1
112   fi
113
114   cp_get_ifaddr "$interface"
115   ipaddress="$RET"
116   if [ -z $ipaddress ]; then
117     echo "cp_get_netaddr: $interface: No IP address found" 1>&2
118     CP_ECHO_RETURN="$echo_return"
119     return 1
120   fi
121   cp_get_ifmask "$interface"
122   netmask="$RET"
123   if [ -z $netmask ]; then
124     echo "cp_get_netaddr: $interface: No netmask found" 1>&2
125     CP_ECHO_RETURN="$echo_return"
126     return 1
127   fi
128
129   if [ "$netmask" = "255.255.255.255" ]; then
130     cidr="$ipaddress/32"
131   else 
132     cidr="`ipcalc -ncb $ipaddress $netmask | awk '/^Network:/{print $2}'`"
133   fi
134   
135   RET="$cidr"
136   [ -z "$echo_return" ] || echo $RET
137   CP_ECHO_RETURN="$echo_return"
138 }
139
140 cp_check_and_backup() {
141   cp_backup_conffile -r "$@"
142 }
143
144 # by ico, Tue, 15 Mar 2005 14:04:21 +0100
145 cp_backup_conffile() {
146   [ "$CP_SCRIPT_DEBUG" ] && set -vx
147   local file_bak check did
148   
149   if [ "x$1" = "x-r" ]; then
150     check=1
151     shift
152   fi
153   if [ -z "$1" ]; then
154     return 1
155   fi
156   if [ ! -f "$1" ]; then
157     echo "cp_backup_conffile: $1: No such file" 1>&2
158     return 2
159   fi
160   if [ -z "$2" ]; then
161     file_bak="/var/backups/`basename $1`.bak"
162   else
163     file_bak="/var/backups/`basename $2`.bak"
164   fi
165
166   if [ ! -f "$file_bak" ]; then
167     cp -pf "$1" "$file_bak"
168     did=1
169   else
170     if ! cmp -s "$1" "$file_bak"; then
171       /usr/bin/savelog -p -c 7 "$file_bak" > /dev/null 2> /dev/null
172       cp -pf "$1" "$file_bak"
173       did=1
174     fi
175   fi
176
177   [ -z "$check" ] && return 0
178
179   if [ "$check" -a ! "$did" ]; then
180     return 3
181   else
182     return 0
183   fi
184 }
185
186 # by jelly, Tue, 15 Mar 2005 14:04:21 +0100
187 # modified by ico, Mon,  6 Jun 2005 11:58:08 +0200
188 # A sed wrapper, to use instead of perl -pi -e
189 #  - relatively safe in-place s///g
190 #  - takes care of symlinks and ownership
191 # returns true if changed, false if nothing happened
192 #
193 cp_check_and_sed() {
194   [ "$CP_SCRIPT_DEBUG" ] && set -vx
195   local s sedcmd grepret ret i
196   if [ -z "$3" ]; then
197     return 1
198   fi
199   s="$1"
200   shift
201   sedcmd="$1"
202   shift
203   ret=2
204   for i in "$@"
205   do
206     [ -e "$i" ]        || continue
207     if ! egrep -q "$s" "$i"; then
208       grepret=1
209       continue
210     fi
211     [ -h "$i" ]        && i=$(readlink -f "$i")
212     sed "$sedcmd" "$i" > "$i.dpkg-tmp"
213     if [ $? -ne 0 ]; then
214       rm "$i.dpkg-tmp"
215       echo "cp_check_and_sed: Problem with sed" 1>&2
216       return 5
217     fi
218     if ! cmp -s "$i" "$i.dpkg-tmp" 2>&1 >/dev/null; then
219       cp_mv "$i.dpkg-tmp" "$i"
220     else
221       rm "$i.dpkg-tmp"
222     fi
223     ret=0
224   done
225   [ "$ret" -eq 2 -a "$grepret" ] && ret=1 || true
226   return $ret
227 }
228
229 # by jelly, Sun, 20 Mar 2005 20:12:19 +0100
230 cp_echo () {
231   [ "$CP_SCRIPT_DEBUG" ] && set -vx
232   if [ "x$1" = "x-mailonly" -o "x$1" = "x-m" ]; then
233     shift
234   else   
235     echo "$*"
236   fi
237   CP_NOTICE="$CP_NOTICE$1"
238   if [ `echo -n "$*" | wc -l` -eq 0 ]; then
239     CP_NOTICE="$CP_NOTICE
240 "
241   fi
242 }   
243
244 # by jelly, Sun, 20 Mar 2005 20:12:19 +0100
245 cp_mail () {
246   [ "$CP_SCRIPT_DEBUG" ] && set -vx
247   local pkg version quiet
248   if [ "x$1" = "x-q" ]; then
249     quiet=1
250     shift
251   fi
252   [ -n "$1" ] && pkg="$1"       # barf if no package
253   [ -n "$2" ] && version=" $2" || true
254   if [ "$(echo $CP_NOTICE|wc -w)" -gt 0 ]; then
255     [ -n "$quiet" ] || echo "Mailing upgrade output to root."
256     CP_NOTICE="From: $pkg postinst script <root>
257 To: root
258 Subject: $pkg$version package install log
259 Date: $(/bin/date +'%a, %d %b %Y %H:%M:%S %z')
260  
261 Hello!
262
263 The $pkg package has been successfully installed on your computer.
264 For your convenience, a partial output of the last $pkg installation
265 is included below.
266
267 ----------
268 ${CP_NOTICE}----------"
269   
270     echo "$CP_NOTICE" | /usr/sbin/sendmail -t &
271     sleep 1
272   fi
273 }
274
275 # by ddzeko, Mon, 21 Mar 2005 11:31:59 +0100
276 cp_mv () {
277   [ "$CP_SCRIPT_DEBUG" ] && set -vx
278   local new old
279   if [ -z "$2" ]; then
280     return 1
281   fi
282   new="$1"
283   old="$2"
284   if [ -e "$old" ]; then
285     chown --reference "$old" "$new"
286     chmod --reference "$old" "$new"
287   fi
288   mv "$new" "$old"
289 }
290
291 # by ddzeko, Mon, 21 Mar 2005 13:35:42 +0100
292 cp_yes_no () {
293   [ "$CP_SCRIPT_DEBUG" ] && set -vx
294   local prompt answer
295   prompt="$1"
296   [ "$prompt" ] || prompt="Are you sure?"
297   RET=""
298
299   # check to prevent user from using this when debconf is active
300   # (it would break communication with its backend - uses stdin/out)
301   if [ "$DEBCONF_REDIR" ]; then
302     echo "cp_yes_no: debconf redirection detected" >&2
303     return 1
304   fi
305
306   echo -n "$prompt (y)es/(n)o: "
307   read answer
308   case "$answer" in
309     y*)
310       echo
311       RET=y
312       ;;
313     n*)
314       echo
315       RET=n
316       ;;
317     *)
318       echo
319       echo "Please read the message and choose y or n"
320       cp_yes_no
321       ;;
322   esac
323 }
324
325 # by ddzeko, Tue, 29 Mar 2005 17:37:52 +0200
326 #
327 # db_get seems to return error messages if the requested variable 
328 # is not found - we do not find that desirable, and checking $? with
329 # set -e turned on seems to be a bit of a problem
330 # --> that's why we wrap the db_get call to return unset RET variable
331 #     instead of some gibberish error message that our script does
332 #     not expect
333 cp_db_get() {
334   local var
335   var="$1"
336   
337   # check to prevent user from using this before activating debconf
338   # confmodule needs to be loaded before accessing db_* functions
339   if [ -z "$DEBCONF_REDIR" ]; then
340     echo "cp_db_get: debconf not activated!" >&2
341     return 1
342   fi
343  
344   if ! db_get "$var"; then
345     case "$RET" in
346         *doesn\'t\ exist)
347           RET=""
348           ;;
349         [0-9][0-9]\ ?*) # other errors
350           RET=""
351           ;;
352     esac
353   fi
354 }
355
356 # by ico, Wed, 20 Apr 2005 21:09:54 +0200
357 cp_get_ldap_suffix() {
358   local echo_return
359   echo_return="$CP_ECHO_RETURN" # since we're making our own calls
360   # in our own way we need to set CP_ECHO_RETURN the way we want it
361   # but preserving initial state so it could be used afterwards
362   CP_ECHO_RETURN=""
363
364   [ "$CP_SCRIPT_DEBUG" ] && set -vx
365
366   if [ ! -f /etc/ldap/slapd.conf ]; then
367     echo "cp_get_ldap_suffix: /etc/ldap/slapd.conf: No such file" >&2
368     return 2
369   fi
370   
371   RET="`awk  '/^suffix/      { exit }
372               END            { gsub(/"/, "", $2); print $2 }' \
373              < /etc/ldap/slapd.conf`"
374
375   if [ "`echo $RET | sed 's/,/ /g' | wc -w`" -gt 2 ]; then
376     RET=""
377     echo "cp_get_ldap_suffix: Invalid LDAP suffix in /etc/ldap/slapd.conf" >&2
378     return 2
379   fi
380     
381   [ -z "$RET" ] && echo "cp_get_ldap_suffix: No LDAP suffix in /etc/ldap/slapd.conf" >&2
382   [ -z "$echo_return" ] || echo $RET
383   CP_ECHO_RETURN="$echo_return"
384 }
385
386 # by ico, Wed, 20 Apr 2005 21:09:54 +0200
387 cp_get_ldap_realm() {
388   local echo_return
389   echo_return="$CP_ECHO_RETURN" # since we're making our own calls
390   # in our own way we need to set CP_ECHO_RETURN the way we want it
391   # but preserving initial state so it could be used afterwards
392   CP_ECHO_RETURN=""
393
394   [ "$CP_SCRIPT_DEBUG" ] && set -vx
395
396   if [ ! -f /etc/ldap/slapd.conf ]; then
397     echo "cp_get_ldap_realm: /etc/ldap/slapd.conf: No such file" >&2
398     return 2
399   fi
400  
401   cp_get_ldap_suffix || true
402   RET="`echo $RET | awk -F, '{print $1}' | awk -F= '{print $2}'`"
403
404   [ -z "$RET" ] && echo "cp_get_ldap_realm: No LDAP REALM in /etc/ldap/slapd.conf" >&2
405   [ -z "$echo_return" ] || echo $RET
406   CP_ECHO_RETURN="$echo_return"
407 }
408